//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//    
int xform(int i)
{
  return i * i;
}


int main(int argc, char* argv[])
{
  list<int> x1;
  int i;
  //    .
  for(i=0; i<10; i++) x1.push_back(i);
  cout << ToRus("  x1: ");
  list<int>::iterator p = x1.begin();
  while(p != x1.end() )
  {
  	cout << *p << " ";
  	p++;
  }
  cout << endl;
  //   x1.
  p = transform(x1.begin(), x1.end(), x1.begin(), xform);

  cout << ToRus("  x1: ");
  p = x1.begin();
  while(p != x1.end())
  {
  	cout << *p << " ";
  	p++;
  }

  getch();
  return 0;
}
//---------------------------------------------------------------------------
